



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>rest_framework 之视图</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">rest_framework 之视图</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 11:18:52 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>1.&nbsp;继承ModelSerilizer,直接指定要序列化的表模型 MySerializers.py</p>
<div>
<pre class="prettyprint linenums">from app import models

# 继承ModelSerilizer,直接指定要序列化的表模型<br />
class BookSerializer(serializers.ModelSerializer):

    class Meta:  # 内部类<br />
        # 指定要序列化book表<br />
        model = models.Book

        # 序列化所有的字段<br />
        fields = '__all__'

    #----------------------------------------------------------------

    #局部钩子校验， 只要是Book 的字段均可以进行局部校验<br />
    def validate_name(self,value):   # value 就是name字段的值<br />
        if value.startswith('sb'):<br />
            raise ValidationError('书名不能以sb开头！')<br />
        else:<br />
            return value

    #全局钩子校验<br />
    def validate(self,attrs):  #　所有的都传过来<br />
        # OrderedDict([('name', 'php'), ('price', Decimal('33.00')), ('publish_date', datetime.date(2019, 3, 18)),<br />
        #              ('publish', &lt; Publish: 北京出版社 &gt;), ('author', [ &lt; Author: liu &gt;])])<br />
        print(attrs)  #是一个字典， 是所有属性的键值对

        return attrs</pre>
</div>
<p>第一层封装：</p>
<div>
<pre class="prettyprint linenums">class BooksView(APIView):<br />
    '''<br />
    book_ser 的data 属性就是 字典<br />
    book_ser = BookSerializer(book_list,many=True)<br />
    response['data']= book_ser.data   # 这里就是将book_list 对象转化成为字典  book_ser.data

    book_ser = BookSerializer(data=request.data)  # 这里是将request.data 字典转换为对象，对象可以存进数据库<br />
    book_ser.save()<br />
    返回给前台的data 仍然是字典 即，book_ser 的data

    book_ser.errors 专门用来放错误信息<br />
    '''

    def get(self,request,*args,**kwargs):<br />
        book_list = Book.objects.all()   # queryset对象，序列化称为列表<br />
        response = {'status':100,'msg':'查询成功'}<br />
        # 使用BookSerializer, 将对象转化成为字典<br />
        book_ser = BookSerializer(book_list,many=True)<br />
        print(book_ser)<br />
        print(book_ser.data)<br />
        response['data']= book_ser.data<br />
        return Response(response)

    def post(self,request):<br />
        # 新增图书<br />
        # 将data取出，反序列化成对象，然后将对象存入数据库，然后前台返回字典信息 book_ser.data<br />
        # 注意添加book 的时候一定选择JSON<br />
        response = {'status':100,'msg':'插入成功'}<br />
        print(request.data)<br />
        try:<br />
            # 将字典反序列化为对象<br />
            book_ser = BookSerializer(data=request.data)<br />
            if book_ser.is_valid():<br />
                book_ser.save()<br />
                response['data'] = book_ser.data<br />
            else:<br />
                response['msg'] = book_ser.errors<br />
        except Exception as e:<br />
            response['msg']=str(e)<br />
        return Response(response)

class SingleBook(APIView):<br />
    # 获得单本图书, get，post 都要request参数<br />
    def get(self,request,id,*args, **kwargs):<br />
        response = {<br />
            'status':100,<br />
            'msg':'查询成功'<br />
        }<br />
        book = Book.objects.filter(pk=id).first()<br />
        book_ser = BookSerializer(instance=book,many=False)<br />
        response['data']=book_ser.data<br />
        return Response(response)

    def put(self,request,id):<br />
        # 修改图书,存入数据库的都是对象，所以要反序列化字典为对象<br />
        response = {<br />
            'status':100,<br />
            'msg': '修改成功！'<br />
        }<br />
        book = Book.objects.filter(pk=id).first()<br />
        try:<br />
            # 这里是修改，不是新增，因此要添加instance 这个字段, 注意这里不是query_set 对象<br />
            book_ser = BookSerializer(instance=book,data=request.data)<br />
            if book_ser.is_valid():<br />
                book_ser.save()<br />
                response['data']=book_ser.data<br />
            else:<br />
                response['data']=book_ser.errors<br />
        except Exception as e:<br />
            response['msg'] = str(e)<br />
        return Response(response)

    def delete(self,request,id):<br />
        # 删除返回的data 为空<br />
        response = {<br />
            'status':100,<br />
            'msg':'删除成功！',<br />
            'data':''<br />
        }<br />
        book = Book.objects.filter(pk=id).delete()  # queryset对象<br />
        return Response(response)</pre>
</div>
<p>第二层封装：</p>
<div>
<pre class="prettyprint linenums"># 以上是对书的增删改查方法， 对作者，出版社同样可以增删改查<br />
#　所以可以将增删改查方法提出来，然后进行调用就可以了<br />
# 继承，封装

# 增删改查，每个方法封装一个类， 继承就可以获得相应的 get, put等方法<br />
# drf 提供的 封装好的类<br />
from rest_framework.mixins import ListModelMixin,RetrieveModelMixin,CreateModelMixin,DestroyModelMixin,UpdateModelMixin<br />
from rest_framework.generics import GenericAPIView

class BookView(ListModelMixin,CreateModelMixin,GenericAPIView):<br />
    '''<br />
    LsitModeMixin 中：<br />
        serializer = self.get_serializer(page, many=True)  ----》 找不到get_serializer 方法<br />
    GenericAPIView ： 有get_serializer 方法<br />
        返回 return serializer_class(*args, **kwargs)， 就是book_ser = BookSerializer(book_list,many=True)<br />
    所以： serializer 就是 book_ser( 序列化后的JSON 数据）<br />
           serializer_class = BookSerializer<br />
    '''<br />
    serializer_class = BookSerializer<br />
    queryset = Book.objects.all()

    # 获得多个<br />
    def get(self,request,*args,**kwargs):<br />
        return self.list(request,*args,**kwargs)<br />
    # 新添<br />
    def post(self,request,*args,**kwargs):<br />
        return self.create(request,*args,**kwargs)

class Single_book(RetrieveModelMixin,UpdateModelMixin,DestroyModelMixin,GenericAPIView):<br />
    '''<br />
    进入 RetrieveModelMixin：  instance = self.get_object()<br />
    进入 GenericAPIView ： get_object() 方法 ----》 get_queryset() ---》 queryset = queryset.all()<br />
    所以： 需要提供 queryset ， 即 queryset = Book.objects.all()<br />
    '''<br />
    serializer_class = BookSerializer<br />
    queryset = Book.objects.all()<br />
    # 获取单条<br />
    def get(self,request,*args,**kwargs):<br />
        return self.retrieve(request,*args,**kwargs)

    def put(self,request,*args,**kwargs):<br />
        return self.update(request,*args,**kwargs)

    def delete(self,request,*args,**kwargs):<br />
        return self.destroy(request,*args,**kwargs)</pre>
</div>
<p>第三层封装：</p>
<div>
<pre class="prettyprint linenums"># 还可以继续封装， 将类中的方法 封装成一个<br />
# 第三层： 使用rest_framework.generics import ListAPIView,ListCreateAPIView<br />
from rest_framework.generics import ListCreateAPIView, RetrieveUpdateDestroyAPIView

# 包含两个方法 get and post<br />
class BookView(ListCreateAPIView):<br />
    serializer_class = BookSerializer<br />
    queryset = Book.objects.all()

# 包含三个方法， get,put,delete<br />
class Single_book(RetrieveUpdateDestroyAPIView):<br />
    serializer_class = BookSerializer<br />
    queryset = Book.objects.all()</pre>
</div>
<p>第四层封装：</p>
<div>
<pre class="prettyprint linenums"># 第四层，可以将五个方法封装到一个类中<br />
# 为了区分两个get 方法， 路由中的as_view() 方法要重写<br />
# url(r'^book/$', views.BooksView.as_view({'get':'list','post':'create'})),<br />
# url(r'^book/(?P&lt;id&gt;\w+)/$', views.SingleBook.as_view({'get':'retrive','put':'update','delete':'destroy'})),

from rest_framework.viewsets import ModelViewSet<br />
class BookView(ModelViewSet):<br />
    queryset = Book.objects.all()<br />
    serializer_class = BookSerializer</pre>
</div>
<p>ViewSetMixin 的使用，重新了as_view 方法</p>
<div>
<pre class="prettyprint linenums"># 经常用ViewSetMixin  只是重写了as_view() 方法<br />
# as_view 就是将字典中的键值对应起来，所以值可以为任意自定义的函数

from rest_framework.viewsets import ViewSetMixin

# 继承属性不能错！！！<br />
class Publish(ViewSetMixin,APIView):<br />
    def aa(self,request):<br />
        return HttpResponse('aa')<br />
    # url(r'^book/$', views.BooksView.as_view({'get': 'aa'})

    def get_all(self,request):  # 就相当于之前定义的list 方法<br />
        pass                    #在路由中与之对应即可

    def create(self,request):<br />
        pass</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxkrvv8.html">MongoVUE1&period;6&period;9破解启动提示System&period;ArgumentException&colon; 字体&OpenCurlyDoubleQuote;Courier New&rdquo;不支持样式&OpenCurlyDoubleQuote;Regular&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ejx7z9.html">HDU-2825 Wireless Password&lpar;AC自动机&plus;状压DP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlw3n68.html">Java中类继承、接口实现的一些细节（长期更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq16vl28.html">习题-任务2初始ASP&period;NET MVC项目开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zzr5n8.html">TIJ读书笔记06-终结清理和垃圾回收</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqv4pdjq.html">iOS开发之网络数据解析--GDataXML解析框架的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4xz5n8.html">Excel加密的Sheet如何hack</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wk0rlq.html">添加删除程序无法安装IIS 提示没法加载模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1nm439.html">【USACO 3&period;1&period;3】丑数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvgej1q.html">iOS 8&period;0正式公布啦</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1dnpgq.html">Linux内核源代码解析之TCP面向字节流</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jjvlw8.html">python学习&mdash;&mdash;编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg56mr8.html">jQuery MiniUI</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg1p548.html">Zepto源码分析-zepto模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2e530q.html">mysql的初次使用操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7onlme8.html">Golang的优雅重启</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy53gdq.html">PHP微信开发之模板消息回复</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o06zk8.html">centos7上安装nagios</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vvo00q.html">e782&period; 排列JList中的项</a>
		</li>
						<li><a href="https://www.batexi.com/a/93p7wvr8.html">java使用WebUploader做大文件的分块和断点续传</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j1lx0g9.html">Oracle&mdash;&mdash;trunc&lpar;&rpar;函数的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllvxrxq.html">分布式异步任务Celery</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zy3xpn9.html">pytorch预训练模型的下载地址以及解决下载速度慢的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2kz52q.html">Java项目中的异常处理情况</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1ywv5q.html">Oracle中如何使用REGEXP&lowbar;SUBSTR函数动态截取字符串</a>
			</li>
						<li><a href="https://www.batexi.com/a/960dnln9.html">flask 操作数据时，db的要在app&period;config设置之后声明：如app&period;config&lbrack;&amp;&num;39&semi;SQLALCHEMY&lowbar;DATABASE&lowbar;URI&amp;&num;39&semi;&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2kmzx9.html">P1744 采购特价商品    最短路径</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvwzyx8.html">vue常见前端UI库</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwg4v48.html">Centosphp安装cassandra扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pwgr648.html">nginx的ip&lowbar;hash负载均衡配置</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
